using DBlazor.HttpClientInterceptor;
using Microsoft.AspNetCore.Components.Builder;
using Microsoft.Extensions.DependencyInjection;
using System;

namespace Blazor.Client
{
    public class Startup
    {
        public void ConfigureServices(IServiceCollection services)
        {
            services.AddDCStorage();  // ע᱾ش洢

            services.AddDCToast();  // עʾ

            services.AddDCLocalisation(); // ע᱾ػ

            services.AddDCHttpClientInterceptor(); // עHttp

            services.AddDCLoadingBar();  // עᶥؽ

            services.AddDCModal();  // עģ̬

            services.AddDCBue(options =>
            {
                options.ChangeTextOnKeyPress = true;
            })
            .AddDCEmptyProviders()
            .AddDCFontAwesomeIcons();  // עAwesomeIcons
        }

        public void Configure(IComponentsApplicationBuilder app)
        {
            app.UseDCLocalisationExtension();  // ػ

            app.UseDCHttpClientInterceptor();  // Http
            //var httpInterceptor = app.Services.GetService<HttpClientInterceptorService>();
            //httpInterceptor.BeforeSend += HttpInterceptor_BeforeSend;
            //httpInterceptor.AfterSend += HttpInterceptor_AfterSend;

            app.UseDCLoadingBar();  // ʹҳض

            app.UseDCFontAwesomeIcons();  //ʹAwesomeIcons

            app.AddComponent<App>("app");
        }

        private void HttpInterceptor_BeforeSend(object sender, EventArgs e)
        {
            Console.WriteLine("BeforeSend event of HttpClientInterceptor");
        }

        private void HttpInterceptor_AfterSend(object sender, EventArgs e)
        {
            Console.WriteLine("AfterSend event of HttpClientInterceptor");
        }
    }
}
